package ai.longev.dev.foreground_bootable_service

import android.app.Activity
import android.app.Notification
import android.content.Intent
import android.os.Build
import android.util.Log
import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel
import io.flutter.plugin.common.MethodChannel.MethodCallHandler
import io.flutter.plugin.common.MethodChannel.Result
import io.flutter.plugin.common.PluginRegistry.Registrar

class  ForegroundBootableServicePlugin(private val activity: Activity) : MethodCallHandler {


  companion object {
    @JvmStatic
    fun registerWith(registrar: Registrar) {
      val channel = MethodChannel(registrar.messenger(), "foreground_bootable_service")
      val activity = registrar.activity()
      channel.setMethodCallHandler(ForegroundBootableServicePlugin(activity))
    }
  }


  override fun onMethodCall(call: MethodCall, result: Result) {
    if (call.method == "getPlatformVersion") {
      maybeStartService()
    } else {
      result.notImplemented()
    }
  }

  private fun maybeStartService() {
    val intent = Intent(activity, ForegroundBootableService::class.java)

    if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.O) {
      activity.startForegroundService(intent)
    } else {
      activity.startService(intent)
    }
  }

}
